﻿/*!
 * MCube UI Library
 * http://www.shellcms.com
 * email:shellcms@gmail.com
 */
MCube = {};
MCube.tree = function(config){
	config = config || {};
	this.initialConfig = config;
	if(config.renderTo){
		this.show();
	}
};
MCube.tree.prototype.show = function(position){
	loadData(this);
	function loadData(context){
		var config = context.initialConfig;
		var param = config.param || {};
		$.ajax({
			type: 'post',
			url: config.url,
			data: param,
			dataType: 'json',
			success: function(data){
				show(data,context);
				bindEvents(context);
			},
			error: function(){
				alert(data);
			}
		});
	}
	function bindEvents(context){
		$('.MCube-tree-node',context.tree).bind("click", function(e){
			$('.MCube-tree-node',context.tree).removeClass('MCube-tree-node-selected');
			$(this).removeClass('MCube-tree-node-over');
			$(this).addClass('MCube-tree-node-selected');
			if(context.initialConfig.onClick){
				context.initialConfig.onClick($.data($(this)[0], 'MCube-tree-node'));
			}
		});
		$('.MCube-tree-node',context.tree).bind("mouseover", function(e){
			if(!$(this).hasClass('MCube-tree-node-selected')){
				$(this).addClass('MCube-tree-node-over');
			}
		});
		$('.MCube-tree-node',context.tree).bind("mouseout", function(e){
			$(this).removeClass('MCube-tree-node-over');
		});
		$('.MCube-tree-expanded',context.tree).bind("click", function(e){
			toggleNode($(this).parent());
			return false;
		});
		if(context.initialConfig.checkbox){
			$('.MCube-tree-node-checkbox',context.tree).bind("click", function(e){
				var children = $(this).parent().next();
				var checked = $(this).attr("checked");
				checked ? $('.MCube-tree-node-checkbox',children).attr("checked",true):$('.MCube-tree-node-checkbox',children).attr("checked","");
				var nodes = $('.MCube-tree-node',children);
				for(var i=0;i<nodes.length;i++){
					var data = $.data(nodes.eq(i)[0], 'MCube-tree-node');
					data.checked = checked ? true : false;
					$.data(nodes.eq(i)[0], 'MCube-tree-node',data);
				}
				var node = $(this).parent();
				var data = $.data(node[0], 'MCube-tree-node');
				data.checked = checked ? true : false;
				$.data(node[0], 'MCube-tree-node',data);
				if(context.initialConfig.onCheck){
					context.initialConfig.onCheck($.data(node[0], 'MCube-tree-node'));
				}
				e.stopPropagation();
			});
		}
		function toggleNode(node){
			var hit = $('>span.MCube-tree-hit', node);
			if (hit.length == 0) return;
			
			if (node.children().hasClass('MCube-tree-expanded')){
				collapseNode(node);
			} else {
				expandNode(node);
			}
		}
		function collapseNode(node){
			var expand = $('>span.MCube-tree-expanded', node).removeClass('MCube-tree-expanded').addClass('MCube-tree-collapsed');
			expand.next().removeClass('MCube-tree-folder-open');
			node.next().css('display','none');
		}
		function expandNode(node){
			var expand = $('>span.MCube-tree-collapsed', node).removeClass('MCube-tree-collapsed').addClass('MCube-tree-expanded');
			expand.next().addClass('MCube-tree-folder-open');
			node.next().css('display','block');
		}
	}
	function show(data,context){
		function appendNodes(position,data,deep){
			var ul = $('<ul></ul>').appendTo(position);
			if(deep==1){
				context.tree = ul;
			}
			for(var i=0; i<data.length; i++){
				var li = $('<li></li>').appendTo(ul);
				var node = $('<div class="MCube-tree-node"></div>').appendTo(li);
				$.data(node[0], 'MCube-tree-node', {
					id: data[i].id,
					text: data[i].text,
					attributes: data[i].attributes,
					checked: data[i].checked ? true : false 
				});
				if (data[i].children){
					appendNodes(li,data[i].children,deep+1);
					for(var j=0; j<deep-1; j++){
						$('<span class="MCube-tree-indent"></span>').appendTo(node);
					}			
					$('<span class="MCube-tree-hit MCube-tree-expanded"></span>').appendTo(node);
					$('<span class="MCube-tree-folder MCube-tree-folder-open"></span>').appendTo(node);
				}else{
					for(var j=0; j<deep; j++){
						$('<span class="MCube-tree-indent"></span>').appendTo(node);
					}
					$('<span class="MCube-tree-leaf"></span>').appendTo(node);
				}
				if (context.initialConfig.checkbox){
					$('<input type="checkbox" class="MCube-tree-node-checkbox" >').appendTo(node);
				}
				$('<span class="MCube-tree-node-text">'+data[i].text+'</span>').appendTo(node);
			}
			
		}
		position = (position==undefined ? $('#'+context.initialConfig.renderTo) : position);
		var tree = $('<div class="MCube-tree"></div>').appendTo(position);
		appendNodes(tree,data,1);
	}
}
MCube.tree.prototype.getSelected = function(){
	var r;
	if($('.MCube-tree-node-selected',this.tree).length>0){
		r = $.data($('.MCube-tree-node-selected',this.tree)[0], 'MCube-tree-node');
		return r;
	}else{
		return null;
	}	
}
MCube.tree.prototype.getChecked = function(attribute){
	var r = [];
	for(var i=0;i<$('.MCube-tree-node',this.tree).length;i++){
		if($.data($('.MCube-tree-node',this.tree).eq(i)[0], 'MCube-tree-node').checked){
			if(attribute){
				r.push($.data($('.MCube-tree-node',this.tree).eq(i)[0], 'MCube-tree-node')[attribute]);
			}else{
				r.push($.data($('.MCube-tree-node',this.tree).eq(i)[0], 'MCube-tree-node'));
			}
		}
	}
	return r;
}
MCube.window = function(config){
	var defaults = {
		width:350,
		height:300,
		paddind:0
	};
	config = $.extend(defaults, config);
	this.initialConfig = config;
	this.init();
};
MCube.window.prototype.init = function(){
	
	function bindEvents(context){
		
	}
}
MCube.window.prototype.show = function(){
	var wnd = $(window), doc = $(document),
	pTop = doc.scrollTop(),	pLeft = doc.scrollLeft(),
	minTop = pTop;	
	pTop += (wnd.height() - this.initialConfig.height) / 2;
	pTop = Math.max(pTop, minTop);
	pLeft += (wnd.width() - this.initialConfig.width) / 2;
	var mWindow ="";
	mWindow += '<div style="left: '+pLeft+'px; top: '+pTop+'px; width: '+this.initialConfig.width+'px; height: '+this.initialConfig.height+'px;" class="MCube-window">';
	mWindow += '	<div class="MCube-window-head">';
	mWindow += '		<div class="MCube-window-title">';
	mWindow += 				this.initialConfig.title ? this.initialConfig.title : "";
	mWindow += '		</div>';
	mWindow += '		<div class="MCube-window-tool-close"></div>';
	mWindow += '	</div>';
	mWindow += '	<div class="MCube-window-body" style="position:relative;height:'+(this.initialConfig.height-56-2*(this.initialConfig.padding))+'px;padding:'+this.initialConfig.padding+'px">';
	mWindow += '	</div>';
	mWindow += '	<div class="MCube-window-foot">';
	mWindow += '	</div>';
	mWindow += '</div>';
	this.window = $("body").append(mWindow);
	if(this.initialConfig.footer){
		for(var i=0;i<this.initialConfig.footer.length;i++){
			this.initialConfig.footer[i].show($('.MCube-window-foot', this.window));
		}
	}
	bindEvents(this);
	function bindEvents(context){
		$('.MCube-window-tool-close', context.window).bind("click", context.close);
	}
}
MCube.window.prototype.add = function(c){
	if(c instanceof jQuery){
		c.appendTo($('.MCube-window-body', this.window))
	}else{
		c.show($('.MCube-window-body', this.window));
	}
}
MCube.window.prototype.close = function(){
	$('.MCube-window', this.window).remove();
}
MCube.button = function(config){
	var defaults = {disabled:false};
	config = $.extend(defaults, config);
	this.initialConfig = config;
	if(config.renderTo){
		this.show();
	}
};
MCube.button.prototype.show = function(position){
	var mButtion ="";
	mButtion += '<a class="MCube-button">';
	mButtion += '	<span>';
	mButtion += 		this.initialConfig.text;
	mButtion += '	</span>';
	mButtion += '</a>';
	position = (position==undefined ? $('#'+this.initialConfig.renderTo) : position);
	this.button = $(mButtion).appendTo(position);
	if(this.initialConfig.disabled){
		this.initialConfig.disabled = false;
		this.disable();
	}else{
		this.initialConfig.disabled = true;
		this.enable();
	}
}
MCube.button.prototype.enable = function(){
	if(this.initialConfig.disabled){
		this.initialConfig.disabled = false;
		this.button.css({ cursor: "pointer", color: "#444444" }); 
		this.button.bind("click", this.initialConfig.onClick);
	}
}
MCube.button.prototype.disable = function(){
	if(!this.initialConfig.disabled){
		this.initialConfig.disabled = true;
		this.button.css({ cursor: "default", color: "#b9b9b9" }); 
		this.button.unbind("click");
	}
}
MCube.imageselect = function(config){
	var defaults = {};
	config = $.extend(defaults, config);
	this.initialConfig = config;
	if(config.renderTo){
		this.show();
	}
};
MCube.imageselect.prototype.init = function(){
	
	function bindEvents(context){
		
	}
}
MCube.imageselect.prototype.show = function(position){
	position = (position==undefined ? $('#'+this.initialConfig.renderTo) : position);
	this.position = position;
	var imgselect = $('<div class="MCube-imgselect"></div>').appendTo(position);
	this.imgselect = imgselect;
	imgselect.html("载入中....");
	loadData(this);
	function loadData(context){
		var config = context.initialConfig;
		var param = config.param || {};
		$.ajax({
			type: 'post',
			url: config.url,
			data: param,
			dataType: 'json',
			success: function(data){
				show(data,context);
				bindEvents(context);
			},
			error: function(){
				alert('发生错误');
			}
		});
	}
	function show(datas,context){
		imgselect.html("");
		for(var i = 0; i<datas.images.length;i++){
			var data = formatData(datas.images[i])
			var wrap = $('<div id="'+datas.images[i].name+'" class="MCube-imgselect-wrap" vsrc="'+datas.images[i].url+'"></div>').appendTo(imgselect);
			var attributes = {};
			for(var attr in datas.images[i]){
				attributes[attr] = datas.images[i][attr];
			}
			$.data(wrap[0], 'MCube-imageselect-image',attributes);
			var thumb = $('<div class="MCube-imgselect-thumb"></div>').appendTo(wrap);
			var img = $('<img style="top: '+data.thumbtop+'; left: '+data.thumbleft+'; width: '+data.thumbwidth+'; height: '+data.thumbheight+';" title="'+datas.images[i].name+'"" src="'+datas.images[i].imgurl+'" />').appendTo(thumb);
			var span = $('<span>'+data.label+'</span>').appendTo(wrap);
		}
	}
	function bindEvents(context){
		$('.MCube-imgselect-wrap',context.imgselect).bind("click", function(e){
			$('.MCube-imgselect-wrap',context.imgselect).removeClass('MCube-imgselect-selected');
			$(this).addClass('MCube-imgselect-selected');
			if(context.initialConfig.onClick){
				context.initialConfig.onClick($.data($(this)[0], 'MCube-imageselect-image'));
			}
		});
		$('.MCube-imgselect-wrap',context.imgselect).bind("mouseover", function(e){
			$('.MCube-imgselect-wrap',context.imgselect).removeClass('MCube-imgselect-over');
			$(this).addClass('MCube-imgselect-over');
		});
		$('.MCube-imgselect-wrap',context.imgselect).bind("mouseout", function(e){
			$('.MCube-imgselect-wrap',context.tree).removeClass('MCube-imgselect-over');
		});
	}
	function formatData(data){
		data.label = (data.name.length > 15)? data.name.substr(0, 12) + '...' : data.name;
		if(data.width > data.height) {
			if(data.width < 80) {
				data.thumbwidth = data.width;
				data.thumbheight = data.height;
			}else{
				data.thumbwidth = 80;
				data.thumbheight = 80 / data.width * data.height;
			}
		}else{
			if(data.height < 80) {
				data.thumbwidth = data.width;
				data.thumbheight = data.height;
			}else{
				data.thumbwidth = 80 / data.height * data.width;
				data.thumbheight = 80;
			}
		}
		data.thumbleft = (Math.round((80 - data.thumbwidth) / 2)) + "px";
		data.thumbtop = (Math.round((80 - data.thumbheight) / 2)) + "px";
		data.thumbwidth = Math.round(data.thumbwidth) + "px";
		data.thumbheight = Math.round(data.thumbheight) + "px";
		return data;
	}
}
MCube.imageselect.prototype.getSelected = function(){
	var r;
	if($('.MCube-imgselect-selected',this.imgselect).length>0){
		r = $.data($('.MCube-imgselect-selected',this.imgselect)[0], 'MCube-imageselect-image');
		return r;
	}else{
		return null;
	}
}
MCube.imageselect.prototype.select = function(condition){
	
}
MCube.imageselect.prototype.reload = function(){
	this.imgselect.remove();
	this.show(this.position);
}
MCube.grid = function(config){
	var defaults = {};
	config = $.extend(defaults, config);
	this.initialConfig = config;
	if(config.renderTo){
		this.show();
	}
};
MCube.grid.prototype.init = function(){
	
	function bindEvents(context){
		
	}
}
MCube.grid.prototype.show = function(position){
	position = (position==undefined ? $('#'+this.initialConfig.renderTo) : position);
	this.position = position;
	var grid = $('<div class="MCube-grid"></div>').appendTo(position);
	
	//var header = $('<div class="MCube-grid-header"></div>').appendTo(grid);
	var headerTable = $('<table border="1px" class="MCube-grid-table"></table>').appendTo(grid);
	var headerTr = $('<tr class="MCube-grid-table-header"></tr>').appendTo(headerTable);
	for(var i=0;i<this.initialConfig.columns.length;i++){
		$('<th style="width:'+this.initialConfig.columns[i].width+'px" class="MCube-grid-header-text">'+this.initialConfig.columns[i].header+'</th>').appendTo(headerTr);
	}
	
	this.grid = grid;
	//grid.html("载入中....");
	loadData(this);
	function loadData(context){
		var config = context.initialConfig;
		var param = config.param || {};
		$.ajax({
			type: 'post',
			url: config.url,
			data: param,
			dataType: 'json',
			success: function(data){
				renderBody(data,context);
				bindEvents(context);
			},
			error: function(){
				alert(123);
			}
		});
	}
	function renderBody(datas,context){
		//var body = $('<div class="MCube-grid-body"></div>').appendTo(grid);
		//var bodyTable = $('<table border="1px" class="MCube-grid-body-table"></table>').appendTo(body);
		for(var i=0;i<datas.length;i++){
			var bodyTr = $('<tr class="MCube-grid-table-body-tr"></tr>').appendTo(headerTable);
			for(var j=0;j<context.initialConfig.columns.length;j++){
				$('<td class="MCube-grid-body-text">'+datas[i][context.initialConfig.columns[j].index]+'</td>').appendTo(bodyTr);
			}
			$.data(bodyTr[0], 'MCube-gridselect-tr',datas[i]);
		}
	}
	function bindEvents(context){
		$('.MCube-grid-table-body-tr',context.grid).bind("mouseover", function(e){
			$('.MCube-grid-table-body-tr',context.grid).removeClass('MCube-grid-table-body-tr-over');
			$(this).addClass('MCube-grid-table-body-tr-over');
		});
		$('.MCube-grid-table-body-tr',context.grid).bind("mouseout", function(e){
			$('.MCube-grid-table-body-tr',context.grid).removeClass('MCube-grid-table-body-tr-over');
		});
		$('.MCube-grid-table-body-tr',context.grid).bind("click", function(e){
			$('.MCube-grid-table-body-tr',context.grid).removeClass('MCube-grid-table-body-tr-selected');
			$(this).addClass('MCube-grid-table-body-tr-selected');
			if(context.initialConfig.onClick){
				context.initialConfig.onClick($.data($(this)[0], 'MCube-gridselect-tr'));
			}
		});
	}
	
}
MCube.grid.prototype.getSelected = function(){
	var r;
	if($('.MCube-grid-table-body-tr-selected',this.grid).length>0){
		r = $.data($('.MCube-grid-table-body-tr-selected',this.grid)[0], 'MCube-gridselect-tr');
		return r;
	}else{
		return null;
	}
}
MCube.grid.prototype.select = function(condition){
	
}
MCube.grid.prototype.reload = function(){
	this.imgselect.remove();
	this.show(this.position);
}
