﻿/*!
 * MCube UI Library
 * http://www.shellcms.com
 * email:shellcms@gmail.com
 */
MCube.imageselect = function(config){
	var defaults = {};
	config = $.extend(defaults, config);
	this.initialConfig = config;
	if(config.renderTo){
		this.show();
	}
};
MCube.imageselect.prototype.init = function(){
	
	function bindEvents(context){
		
	}
}
MCube.imageselect.prototype.show = function(position){
	position = (position==undefined ? $('#'+this.initialConfig.renderTo) : position);
	this.position = position;
	var imgselect = $('<div class="MCube-imgselect"></div>').appendTo(position);
	this.imgselect = imgselect;
	imgselect.html("载入中....");
	loadData(this);
	function loadData(context){
		var config = context.initialConfig;
		var param = config.param || {};
		$.ajax({
			type: 'post',
			url: config.url,
			data: param,
			dataType: 'json',
			success: function(data){
				show(data,context);
				bindEvents(context);
			},
			error: function(){
				alert('发生错误');
			}
		});
	}
	function show(datas,context){
		imgselect.html("");
		for(var i = 0; i<datas.images.length;i++){
			var data = formatData(datas.images[i])
			var wrap = $('<div id="'+datas.images[i].name+'" class="MCube-imgselect-wrap" vsrc="'+datas.images[i].url+'"></div>').appendTo(imgselect);
			var attributes = {};
			for(var attr in datas.images[i]){
				attributes[attr] = datas.images[i][attr];
			}
			$.data(wrap[0], 'MCube-imageselect-image',attributes);
			var thumb = $('<div class="MCube-imgselect-thumb"></div>').appendTo(wrap);
			var img = $('<img style="top: '+data.thumbtop+'; left: '+data.thumbleft+'; width: '+data.thumbwidth+'; height: '+data.thumbheight+';" title="'+datas.images[i].name+'"" src="'+datas.images[i].imgurl+'" />').appendTo(thumb);
			var span = $('<span>'+data.label+'</span>').appendTo(wrap);
		}
	}
	function bindEvents(context){
		$('.MCube-imgselect-wrap',context.imgselect).bind("click", function(e){
			$('.MCube-imgselect-wrap',context.imgselect).removeClass('MCube-imgselect-selected');
			$(this).addClass('MCube-imgselect-selected');
			if(context.initialConfig.onClick){
				context.initialConfig.onClick($.data($(this)[0], 'MCube-imageselect-image'));
			}
		});
		$('.MCube-imgselect-wrap',context.imgselect).bind("mouseover", function(e){
			$('.MCube-imgselect-wrap',context.imgselect).removeClass('MCube-imgselect-over');
			$(this).addClass('MCube-imgselect-over');
		});
		$('.MCube-imgselect-wrap',context.imgselect).bind("mouseout", function(e){
			$('.MCube-imgselect-wrap',context.tree).removeClass('MCube-imgselect-over');
		});
	}
	function formatData(data){
		data.label = (data.name.length > 15)? data.name.substr(0, 12) + '...' : data.name;
		if(data.width > data.height) {
			if(data.width < 80) {
				data.thumbwidth = data.width;
				data.thumbheight = data.height;
			}else{
				data.thumbwidth = 80;
				data.thumbheight = 80 / data.width * data.height;
			}
		}else{
			if(data.height < 80) {
				data.thumbwidth = data.width;
				data.thumbheight = data.height;
			}else{
				data.thumbwidth = 80 / data.height * data.width;
				data.thumbheight = 80;
			}
		}
		data.thumbleft = (Math.round((80 - data.thumbwidth) / 2)) + "px";
		data.thumbtop = (Math.round((80 - data.thumbheight) / 2)) + "px";
		data.thumbwidth = Math.round(data.thumbwidth) + "px";
		data.thumbheight = Math.round(data.thumbheight) + "px";
		return data;
	}
}
MCube.imageselect.prototype.getSelected = function(){
	var r;
	if($('.MCube-imgselect-selected',this.imgselect).length>0){
		r = $.data($('.MCube-imgselect-selected',this.imgselect)[0], 'MCube-imageselect-image');
		return r;
	}else{
		return null;
	}
}
MCube.imageselect.prototype.select = function(condition){
	
}
MCube.imageselect.prototype.reload = function(){
	this.imgselect.remove();
	this.show(this.position);
}
